# Written and Refactor by keihan haqiq github@patpaws

from datasketch import MinHash
#import farmhash



def compute_minhash_signatures(string, num_perm=128):
    m = MinHash(num_perm=num_perm)
    for token in string.split():
        m.update(token.encode('utf8'))
    return m

def compute_minhash_signatures_char(string, num_perm=128):
    m = MinHash(num_perm=num_perm)
    for n in string :
        m.update(n.encode('utf8'))
    return m

def jaccard_similarity(set1, set2):
    intersection_size = len(set1.intersection(set2))
    union_size = len(set1.union(set2))
    return intersection_size / union_size

def PowerMinHashOnChar(string1, string2, perm=128) :

    # Compute MinHash signatures for the strings
    m1 = compute_minhash_signatures_char(string1)
    m2 = compute_minhash_signatures_char(string2)

    # Create MinHashLSH index
    lsh = MinHashLSH(threshold=0.5, num_perm=perm)
    lsh.insert("m2", m2)

    # Query the LSH index with the MinHash signature of string1
    result = lsh.query(m1)
    return result;

    # # Compute Jaccard similarity between string1 and its approximate neighbor(s)
    # similarity_scores = [(candidate, lsh.jaccard_from_keys(m1, candidate)) for candidate in result]






    print("Approximate neighbors with Jaccard similarity > 0.5:", similarity_scores)
    return similarity_scores;



def PowerMinHashOnTok(string1, string2, perm = 128) :

    # Compute MinHash signatures for the strings
    m1 = compute_minhash_signatures(string1)
    m2 = compute_minhash_signatures(string2)

    # Create MinHashLSH index
    lsh = MinHashLSH(threshold=0.5, num_perm=perm)
    lsh.insert("m2", m2)


    # Query the LSH index with the MinHash signature of string1
    result = lsh.query(m1)
    help(lsh)
    #
    # # Compute Jaccard similarity between string1 and its approximate neighbor(s)
    # similarity_scores = [(candidate, lsh.jaccard_from_keys(m1, candidate)) for candidate in result]

    return result;



    print("Approximate neighbors with Jaccard similarity > 0.5:", similarity_scores)
    return similarity_scores;



# for now its good to use the raw
# def custom(b) : 
#     return farmhash.hash32(b.decode('utf-8'));

def compute_minhash_signature(tokens,perm):
    minhash = MinHash(num_perm=perm)
    for token in tokens:
        minhash.update(token.encode('utf8'))
    return minhash

def jaccard_similarity(sig1, sig2):
    return sig1.jaccard(sig2)


def tok(s) :
    t = []
    for n in s :
        t.append(n);
    return t

def withMin_token(st,st2 ) :

    tokens1 = set(st.split())
    tokens2 = set(st.split())

    signature1 = compute_minhash_signature(tokens1)
    signature2 = compute_minhash_signature(tokens2)

    similarity = jaccard_similarity(signature1, signature2)
    return similarity


# generate signature on characters
def generateSignature(st,perm) :
    # use signature for later compare and store.
    tokens = set(tok(st))


    signature = compute_minhash_signature(tokens,perm)
    return signature

# jaccard similarity on two sigs.
def checkForSimilarity(sig1,sig2) :

    return jaccard_similarity(sig1, sig2)



def withMin_Char(st,st2,perm=100 ) :

    tokens1 = set(tok(st))
    tokens2 = set(tok(st2))

    signature1 = compute_minhash_signature(tokens1,perm)
    signature2 = compute_minhash_signature(tokens2,perm)

    similarity = jaccard_similarity(signature1, signature2)
    return similarity


# Example usage:

if __name__ == "__main__":

    pass;
