# Written and Refactor by keihan haqiq github@patpaws
from minCache.sign import hash_string , hash_string_farm
from minCache.helpers import check_type
class Processor :
    def __init__ (self) :
        self.plugins = [];
        pass;

    # if return false from : we have to return invalid to the user
    # if not we remove the whitespaces and hash the string
    # after done all the things such as removing whitespaces and add plugins(optinoal) return the single hash as sign
    def PreProcess(self, value) :

        # two things are the base
        vs = value.strip().lower();

        if len(vs) == 0 :
            # empty value : nothing to do with it
            return False
        # after apply the plugins we hash the string
        #print(value);
        return hash_string_farm(self.applyPlugins(vs));


    def applyPlugins(self, value) :


        vs = None;
        if len(self.plugins) != 0 :
            for p in self.plugins :
                # we support a waterfall of plugins to transfmr the value before hash it
                temp = p(value);
                if check_type(temp) == 'str' :
                    vs = temp;
                else :
                    pass
                    #print('cant use the value of the applied plugin : its not str');


        # more checking
        if vs != None and check_type(vs) == 'str' :
            #print(vs);
            return vs

        #print('something wrong with your plugins returns : falll back to the original value');
        return value;



    # add plugin in i [] 0 : input -> compresss -> output
    # lots of things must checked here and allow only funcs and methods : must check for type and any other sort of stuffs and return type must be string
    # add plugin can be used in chain
    def addPlugin(self,func) :
        vType  = check_type(func);
        if vType == 'function' :
            #print('func added');
            self.plugins.append(func);
        else :

            #print('cant append the plugin its a not function');
            #print('if you use objects : wrap it in some function call and return obj.metCall or what method it support as fn call an use it');
            pass
        return self

    # value that is used to show to the user or parsed
    def PostProcess(self,value) :
        # only parse this : LIST[DICT]
        # you can undo your plugins : uncompress the data for showing
        # or do some changes to the value before showing to the user : title it or what 4ever
        # grab the best score or raw
        if res:= self.handleReturnValueBasedOnType(value) :
            # this is the Postprocessed version  of this
            return res;


        #print('cant post process the value so return value');
        return value;




    def handleReturnValueBasedOnType(self, value) :
        match value['typi']:
            case 'llm-raw':
                return value, self.applyPlugins(value['value']);
            case 'cache-out':
                return value, self.applyPlugins(value['value'][0]['value']);
            case 'exact':
                return value, self.applyPlugins(value['value'][0]['value']);
            case 'error' :
                # dont do plugins
                return value['value'][0]['value']
            case _:
                return False



# test

def main() :
    p = Processor()
    res = p.PreProcess('          helooo         babes');
    print(res)
    res , d = p.PostProcess({
        'value':[{'value' : 'are you good'}] ,
        'typi' : 'exact'
    })

    print(res);
    print(d);

    pass;




# third party wrappers that do transforming on your data
def Title(st) :
    return st.title();


if __name__ == "__main__" :
    main();
