# Written and Refactor by keihan haqiq github@patpaws
# The Similarity class has two modes, 'cosine' and 'minHash', and provides methods to generate representations and calculate similarity scores.
from minhash import generateSignature , checkForSimilarity;

class Similarity() :

    def __init__(self,perm=100) :
        self.mode = 'minHash' ;
        self.perm = perm
        self.generateSig = generateSignature;
        self.similarScore = checkForSimilarity;

    def generateRep(self, v) :

        return self.generateSig(v , self.perm)

    def checkAgainst(self , sig1, sig2) :
        return self.similarScore(sig1,sig2);
# test
def main() :

    sim = Similarity(perm=100)
    res = sim.checkAgainst(sim.generateRep('hi'), sim.generateRep('good'));
    print(res, 'minHash');



if __name__ == "__main__" :
    main();
