import hashlib
import random
import string
import farmhash

# our faster apporach to fhashing
# def fasterHashFunc(string) :
#     return farmhash.hash32(string.encode('utf-8'))


def hash_string_farm(string) :
    return hex(farmhash.fingerprint64(string))

def hash_string(string):
    # create hash object using sha-256 algorithm
    hash_object = hashlib.sha256()

    # convert the string to utf-8 readable bytes and update the hashObjj
    hash_object.update(string.encode('utf-8'))

    # Get the hashed string in hexadecimal form
    hashed_string = hash_object.hexdigest()

    return hashed_string

# use for mock the dataset responses
def grs(length):
    """
    Generates a random string of the specified length.

    Parameters:
    length (int): The desired length of the random string.

    Returns:
    str: A random string of the specified length.
    """
    characters = string.ascii_letters + string.digits
    return ''.join(random.choice(characters) for i in range(length))

def main() :


    # print(hash_string(grs(100)))
    # print(hash_string_farm(grs(100)))


    # print('------');
    # print(hash_string('hello world'));
    print(hash_string_farm('hello world'))

    # # Example usage
    # string_to_hash = "Hello World"
    # hashed_string = hash_string(string_to_hash)
    # print(hashed_string);

    # string_to_hash = "Hello world"
    # hashed_string = hash_string(string_to_hash)
    # print(hashed_string)

    # string_to_hash = "Hello World"
    # hashed_string = hash_string(string_to_hash)
    # print(hashed_string);

    # string_to_hash = "Hello world"
    # hashed_string = hash_string(string_to_hash);
    # print(hashed_string)

# for test
if __name__ == "__main__" :
    main();
